<template>
  <div class="block">
    <ol>
      <li><span value=1>1</span><p>${ _('Definitely False') }</p></li>
      <li><span value=2>2</span><p>${ _('Mostly or Probably False') }</p></li>
      <li><span value=3>3</span><p>${ _('Neither True nor False, or About Equally True or False') }</p></li>
      <li><span value=4>4</span><p>${ _('Mostly or Probably True') }</p></li>
      <li><span value=5>5</span><p>${ _('Definitely True') }</p></li>
    </ol>

    <form>
      <p>${ _(state.question) }</p>
      <nav>
        <button @click="submit" value=1>1</button>
        <button @click="submit" value=2>2</button>
        <button @click="submit" value=3>3</button>
        <button @click="submit" value=4>4</button>
        <button @click="submit" value=5>5</button>
      </nav>
    </form>
    <p id=progress>${state.index + 1}/${state.total}</p>
  </div>
</template>

<script>
  export default class extends Lego {
    init() {
      this.time = null
      this.times = []
      this.time = new Date()
      this.answers = []
      this.state = {
        token: '',
        index: 0,
        total: 0,
        questions: [],
        question: ''
      }
    }

    connected() {
      this.render({ question: this.state.questions[0], total: this.state.questions.length })
    }

    submit(event) {
      event.preventDefault()
      const duration = (new Date()) - this.time
      if (duration < 600) return
      this.answers[this.state.index] = event.target.value
      this.times[this.state.index] = duration
      this.time = new Date()
      if (this.state.questions.length <= this.state.index + 1) return this.send()
      this.state.index++
      this.render({ question: this.state.questions[this.state.index] })
    }

    async send() {
      const data = { answers: this.answers, times: this.times }
      const response = await api(`/assignment/${this.state.token}/complete`, { data })
      if (!response.ok) return alert(_("Can't save your data right now. Keep this window and try a little later."))
      page('/end')
    }
  }
</script>

<style>
  @import url('/assets/css/main.css');

  ol {
    display: flex;
    justify-content: space-around;
  }
  ol li {
    display: block;
    text-align: center;
    max-width: 14rem;
  }
  ol li span {
    display: inline-block;
    margin: 0 auto;
    padding: .2rem .6rem;
    border: 1px solid #ccc;
    border-radius: .2rem;
  }

  form {
    display: flex;
    justify-content: space-between;
    align-items: start;
    border-top: 1px solid #eee;
    max-width: 60rem;
    margin: 2rem auto;
    min-height: 8rem;
    padding-top: 2rem;
  }
  form p,
  form button {
    font-size: 1.1rem;
    margin-top: 0;
  }
  form nav {
    display: flex;
  }
  form button:hover {
    background-color: var(--light-color);
    color: #fff;
  }

  #progress {
    text-align: right;
  }
</style>
